package it.unibo.sd1819.lab10.agents.behaviours;

import alice.tuprolog.Term;
import it.unibo.sd1819.lab10.agents.AgentController;
import it.unibo.sd1819.lab10.agents.behaviours.messages.Notification;
import it.unibo.sd1819.lab10.agents.behaviours.messages.Subscription;
import it.unibo.sd1819.lab10.ts.logic.LogicTemplate;
import it.unibo.sd1819.lab10.ts.logic.LogicTuple;

abstract class Subscribe implements Behaviour {

    private boolean subscribed = false;

    private final Behaviour subscribeBehaviour = null; // TODO implement me

    private final Behaviour handleNotificationsBehaviour = null; // TODO implement me

    @Override
    public void execute(AgentController ctl) throws Exception {
        if (subscribed) {
            handleNotificationsBehaviour.execute(ctl);
        } else {
            subscribeBehaviour.execute(ctl);
        }
    }

    @Override
    public boolean isPaused() {
        if (subscribed) {
            return handleNotificationsBehaviour.isPaused();
        } else {
            return subscribeBehaviour.isPaused();
        }
    }

    @Override
    public boolean isOver() {
        if (subscribed) {
            return handleNotificationsBehaviour.isOver();
        } else {
            return subscribeBehaviour.isOver();
        }
    }

    @Override
    public Behaviour deepClone() {
        // do not edit this method!
        throw new IllegalStateException("You must override the deepClone method in class " + this.getClass().getName());
    }

    private Term getNotificationTemplate(AgentController ctl) {
        return Notification.getTemplate(getTopic(ctl));
    }

    public abstract Object getTopic(AgentController ctl);

    private Subscription getSubscription(AgentController ctl) {
        return new Subscription(ctl.getAgentId(), getTopic(ctl));
    }

    // TODO call this method after subscription has been performed
    public abstract void onSubscribed(AgentController ctl, Subscription subscription) throws Exception;

    // TODO call this method whenever a notification has been received matching the topic generated by getTopic()
    public abstract void onNotified(AgentController ctl, Notification subscription) throws Exception;
}
